import pygame

from pygame.locals import * 

from utils import *

class Effect:
	length = None
	on = None
	started_time = None
	sound = None
	loop = None
	
	def __init__(self, filename):
		self.sound = utils.load_sound(filename)
		self.sound.set_volume(0.3)
		self.on = False
		self.length = self.sound.get_length()*1000

		self.started_time = 0
		self.loop = False
		
	def Play(self, time, loop):
		if self.on:
			return
			
		self.loop = loop
		self.on = True
		self.sound.play()
		self.started_time = time

		
	def Update(self, time):
		if self.on:
			if time >= self.started_time + self.length:
				if self.loop:
					self.sound.play()
					self.started_time = time
	
	def Stop(self):
		if not self.on:
			return

		self.sound.stop()
		self.started_time = 0
		self.on = False