import pygame
import math

#utils functions - loading things
from utils import *

from vector2d import *

class Fader:
	is_fading = None
	current_alpha = None
	speed = 255 / 2000.
	surface = None
	
	def __init__(self, surface):
		self.surface = surface
		self.Reset()
	
	def StartFading(self):
		if(self.is_fading):
			return

		self.Reset()
		self.is_fading = True
	
	def Reset(self):
		self.is_fading = False
		self.current_alpha = 0
		self.surface.set_alpha(self.current_alpha)
	
	def IsFading(self):
		return self.is_fading
	
	def Update(self, elapsed_time):
		if not self.is_fading:
			return
		if self.current_alpha == 255:
			return

		self.current_alpha = self.current_alpha + int(self.speed * elapsed_time)
		if self.current_alpha > 255:
			self.current_alpha = 255

		self.surface.set_alpha(self.current_alpha)
		
	def GetSurface(self):
		return self.surface