import random

# A simple effect of sliding stars to create a deep space sensation.
# by Silveira Neto <me@silveiraneto.net>
# Free under the terms of GPLv3 license
# See http://silveiraneto.net/2009/08/12/pygame-simple-space-effect/
 
import os,sys,random
import pygame
from pygame.locals import *
 
# Constants 
N = 300

class Stars:
	stars = None
	background = None
	screen_dim = None
	
	def __init__(self, dim):
		self.stars = [
			[random.randint(0, dim[0]),random.randint(0, dim[1]), random.randint(0,2)]
			for x in range(N)
			]
		self.background = pygame.Surface((dim[0], dim[1]))
		self.background = self.background.convert()
		self.screen_dim = dim
		
	def GetSurface(self, offset):
		self.background.fill((0,0,0))
		for star in self.stars:
			star[0] = (star[0] - offset.x) % self.screen_dim[0]
			star[1] = (star[1] - offset.y) % self.screen_dim[1]
			
			#optional -- generate new
			# if star[0] < 0:
				# star[0] = self.screen_dim[0]
				# star[1] = random.randint(0, self.screen_dim[1])
				# star[2] = random.randint(0,2)
		
			if star[2] == 0:
				color = (255, 255, 255)
			elif star[2] == 1:
				color = (150, 150, 150)
			elif star[2] == 2:
				color = (80, 80, 80)
			
			pygame.draw.line(self.background,
				color, (star[0], star[1]), (star[0], star[1]))


		return self.background
		