#!/usr/bin/python

import pygame
import os
from pygame.locals import *
import math

EPSILON = 10**-5

#distance constants
safe_zone_rad_sqr = 300**2
moderate_ast_rad_sqr = 1000**2
ast_end_rad_sqr = 2000**2

arrived_rad = 2500
arrived_rad_sqr = arrived_rad**2

#compute circumference - know how large to scale our destinations
field_circ = 2*math.pi*arrived_rad


class utils:
	@classmethod
	def load_image(cls, file_name, colorkey=None):
	  full_name = os.path.join('graphics', file_name)

	  try:
		image = pygame.image.load(full_name)
	  except pygame.error, message:
		print 'Cannot load image:', full_name
		raise SystemExit, message

	  image = image.convert()

	  if colorkey is not None:
		if colorkey is -1:
		  colorkey = image.get_at((0,0))
		image.set_colorkey(colorkey, RLEACCEL)

	  return image, image.get_rect()
	
	@classmethod
	def load_sound(cls, name):
		fullname = os.path.join('sound', name)
		try:
			sound = pygame.mixer.Sound(fullname)
		except pygame.error, message:
			print 'Cannot load sound:', wav
			raise SystemExit, message
		return sound