import math

class Vector2d:
	x = None
	y = None
	
	def __str__(self):
			return "(%5.2f, %5.2f)" % (self.x, self.y)
	
	def __init__(self, tup):
		self.x, self.y = tup
	
	@classmethod
	def FromXY(cls, x, y):
		return cls((x, y))
	
	@classmethod
	def FromVector(cls, vec):
		return cls((vec.x, vec.y))
	
	def copy(self):
		return Vector2d.FromVector(self)
		
	def Magnitude(self):
		ret = math.sqrt(self.x**2 + self.y**2)
		return ret

	def MagnitudeSquared(self):
		ret = (self.x**2 + self.y**2)
		return ret
	
	def Normalize(self):
		m = self.Magnitude()
		return self.Div(m)
	
	def Dot(self, vec2):
		return self.x * vec2.x + self.y * vec2.y
	
	def tup(self):
		return (self.x, self.y)
		
	def Mul(self, amount):
		return Vector2d((self.x * amount, self.y * amount))

	def Div(self, amount):
		return Vector2d((self.x / amount, self.y / amount))
	
	def __iadd__(self, vec2):
		self.x += vec2.x
		self.y += vec2.y
		return self
		
	def __isub__(self, vec2):
		self.x -= vec2.x
		self.y -= vec2.y
		return self
		
	def __sub__(self, vec2):
		return Vector2d((self.x - vec2.x, self.y - vec2.y))
	
	def __add__(self, vec2):
		return Vector2d((self.x + vec2.x, self.y + vec2.y))